#ifndef __GMAP_H__
#define __GMAP_H__

#include <qwidget.h>
#include <qvbox.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qpixmapcache.h>
#include <qpoint.h>
#include <qarray.h>
#include <qcache.h>

#include "map.h"
#include "qgmap.h"
#include "qgconf.h"
#include "scale.h"

class GMap : public QWidget
{
	Q_OBJECT
  public:
	GMap( QWidget *parent =0, const char *name = 0, WFlags fl = 0);
	void updateCenter(bool force);
	void paintEvent( QPaintEvent *e );
	void wheelEvent( QWheelEvent *e );
	void mouseMoveEvent( QMouseEvent *e );
	void mousePressEvent( QMouseEvent *e );
	void mouseReleaseEvent( QMouseEvent *e );

	void keyPressEvent ( QKeyEvent * e );
	void keyReleaseEvent ( QKeyEvent * e );

  private:
	int is_initialized;

	int x_num;
	int y_num;

	int load_top;
	int load_left;

	Pos center;
	QPixmapCache cache;
	QCache<QImage> img_cache;

	QArray<Map *> pix;

	QPixmap scr;

	bool is_map_click;
	bool is_scale_click;
	QPoint click_pos;

	QGConf conf;
	QString map_path;

	QPixmap menu_pic;

	QPopupMenu popup_menu;

	void loadMap(Pos loadpos);

	void scroll(int x, int y);
	void zoomup(int z);

	Scale *scale;

  public slots:

	void menu_activated(int id);
};

#endif // __GMAP_H__
